#!/bin/sh

### Todo ###
# 1. Script does not work for CH7466CE, when user is already logged in

CWD=$(dirname $0)

source $CWD/../static.conf

ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)

get_token(){
	token=$(cat cookie.txt | grep sessionToken | awk '{print $7}')
	rm cookie.txt
}

logout(){
    curl -s \
        -H "Host: $ROUTER_IP" \
        -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0" \
        -H "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8" \
        -H "Accept-Language: en-US,en;q=0.5" \
        -H "Accept-Encoding: gzip, deflate" \
        -H "DNT: 1" \
        -H "Connection: keep-alive" \
        -H "Upgrade-Insecure-Requests: 1" \
        -H "Pragma: no-cache" \
        -H "Cache-Control: no-cache" \
        -c "cookie.txt" \
        "http://$ROUTER_IP/" > /dev/null
    get_token
    data="token=$token&fun=5"
    curl -s \
        -H "Host: $ROUTER_IP" \
        -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0" \
        -H "Accept: application/xml, text/xml, */*; q=0.01" \
        -H "Accept-Language: en-US,en;q=0.5" \
        -H "Accept-Encoding: gzip, deflate" \
        -H "Referer: http://$ROUTER_IP/common_page/status.html" \
        -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
        -H "X-Requested-With: XMLHttpRequest" \
        -H "DNT: 1" \
        -H "Connection: keep-alive" \
        -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
        -c "cookie.txt" \
        -d "$data" \
        "http://$ROUTER_IP/xml/getter.xml" > /dev/null
    get_token
    curl -s \
        -H "Host: $ROUTER_IP" \
        -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0" \
        -H "Accept: application/xml, text/xml, */*; q=0.01" \
        -H "Accept-Language: en-US,en;q=0.5" \
        -H "Accept-Encoding: gzip, deflate" \
        -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
        -H "X-Requested-With: XMLHttpRequest" \
        -H "Referer: http://$ROUTER_IP/common_page/status.html" \
        -H "DNT: 1" \
        -H "Connection: keep-alive" \
        -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
        "http://$ROUTER_IP/common_page/login.html" > /dev/null
}

curl -s \
	-H "Host: $ROUTER_IP" \
	-H "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8" \
	-H "Accept-Language: en-US,en;q=0.5" \
	-H "Accept-Encoding: gzip, deflate" \
	-H "DNT: 1" \
	-H "Connection: keep-alive" \
	-H "Upgrade-Insecure-Requests: 1" \
	-c "cookie.txt" \
	"http://$ROUTER_IP/" > /dev/null
get_token
if [ -n "$token" ]
then
    curl -s \
        -H "Host: $ROUTER_IP" \
        -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
        -H "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8" \
        -H "Accept-Language: en-US,en;q=0.5" \
        -H "Accept-Encoding: gzip, deflate" \
        -H "DNT: 1" \
        -H "Connection: keep-alive" \
        -H "Upgrade-Insecure-Requests: 1" \
        -H "If-Modified-Since: Thu, 30 Mar 2017 10:30:30 GMT" \
        -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
        -c "cookie.txt" \
        "http://$ROUTER_IP/common_page/login.html" > login_page.txt
    login_page=$(cat login_page.txt)
    rm login_page.txt
    get_token
    if [ -n "$(echo $login_page | grep 'Compal Broadband Networks')" ]
    then
        data="token=$token&fun=3"
        curl -s \
            -H "Host: $ROUTER_IP" \
            -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0" \
            -H "Accept: application/xml, text/xml, */*; q=0.01" \
            -H "Accept-Language: en-US,en;q=0.5" \
            -H "Accept-Encoding: gzip, deflate" \
            -H "Referer: http://$ROUTER_IP/common_page/login.html" \
            -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
            -H "X-Requested-With: XMLHttpRequest" \
            -H "DNT: 1" \
            -H "Connection: keep-alive" \
            -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
            -c "cookie.txt" \
            -d "$data" \
            "http://$ROUTER_IP/xml/getter.xml" > /dev/null
        get_token
        login_data="token=$token&fun=15&Username=admin&Password=${ROUTER_PASSWORD}"
        login_resp=$(curl -s \
        	-H "Host: $ROUTER_IP" \
        	-H "Accept: text/plain, */*; q=0.01" \
            -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0" \
        	-H "Accept-Language: en-US,en;q=0.5" \
        	-H "Accept-Encoding: gzip, deflate" \
        	-H "Referer: http://$ROUTER_IP/common_page/login.html" \
        	-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
        	-H "X-Requested-With: XMLHttpRequest" \
        	-H "DNT: 1" \
        	-H "Connection: keep-alive" \
        	-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
        	-c "cookie.txt" \
        	-d "$login_data" \
        	"http://$ROUTER_IP/xml/setter.xml")
        get_token
        changePW=$(echo $login_resp | grep KDGchangePW)
        if [ "$login_resp" = "successful" ] || [ -n "$changePW" ]
        then
            data="token=$token&fun=1"
            get_resp=$(curl -s \
            	-H "Host: $ROUTER_IP" \
            	-H "Accept: application/xml, text/xml, */*; q=0.01" \
                    -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0" \
            	-H "Accept-Language: en-US,en;q=0.5" \
            	-H "Accept-Encoding: gzip, deflate" \
            	-H "Referer: http://$ROUTER_IP/wifi_page/wlanRadio.html" \
            	-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
            	-H "X-Requested-With: XMLHttpRequest" \
            	-H "DNT: 1" \
            	-H "Connection: keep-alive" \
            	-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
            	-c "cookie.txt" \
            	-d "$data" \
                    "http://$ROUTER_IP/xml/getter.xml")
            MODEL=$(echo $get_resp | \
                awk -F'<SwVersion>' '{print $2}'| \
                awk -F'-' '{print $1}')
            if [ -z "$MODEL" ]
            then
                echo "Given router password is incorrect."
                exit 1
            else
                echo "Compal $MODEL" > "$CWD/../router.txt"
            fi
            # Logout
            get_token
            data="token=$token&fun=1"
            curl -s \
                -H "Host: $ROUTER_IP" \
                -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
                -H "Accept: application/xml, text/xml, */*; q=0.01" \
                -H "Accept-Language: en-US,en;q=0.5" \
                -H "Accept-Encoding: gzip, deflate" \
                -H "Referer: http://$ROUTER_IP/index.html" \
                -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
                -H "X-Requested-With: XMLHttpRequest" \
                -H "DNT: 1" \
                -H "Connection: keep-alive" \
                -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
                -c "cookie.txt" \
                -d "$data" \
                "http://$ROUTER_IP/xml/getter.xml" > /dev/null
            get_token
            data="token=$token&fun=16"
            curl -s \
                -H "Host: $ROUTER_IP" \
                -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
                -H "Accept: text/plain, */*; q=0.01" \
                -H "Accept-Language: en-US,en;q=0.5" \
                -H "Accept-Encoding: gzip, deflate" \
                -H "Referer: http://$ROUTER_IP/index.html" \
                -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
                -H "X-Requested-With: XMLHttpRequest" \
                -H "DNT: 1" \
                -H "Connection: keep-alive" \
                -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
                -d "$data" \
                -c "cookie.txt" \
                "http://$ROUTER_IP/xml/setter.xml" > /dev/null
            get_token
        elif [ "$login_resp" = "KDGloginincorrect" ]
        then
            echo "Given router password is incorrect."
            exit 1
        else
            logout
        fi
    else
        echo "Router model is no supported."
        exit 1
    fi
else
    curl_output=$(curl -s \
        -H "Host: $ROUTER_IP" \
        -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
        -H "Accept: application/xml, text/xml, */*" \
        -H "Accept-Language: en-US,en;q=0.5" \
        -H "Accept-Encoding: gzip, deflate" \
        -H "Referer: http://$ROUTER_IP/" \
        -H "X-Requested-With: XMLHttpRequest" \
        -H "DNT: 1" \
        -H "Connection: keep-alive" \
        "http://$ROUTER_IP/xml/GlobalSettings.xml")
    MODEL=$(echo $curl_output | \
        awk -F'<PlatformType>' '{print $2}' | \
        awk -F'<' '{print $1}')
    if [ -n "$MODEL" ]
    then
        echo "Compal $MODEL" > "$CWD/../router.txt"
    else
        echo "Router model is not supported or wrong gateway router IP address."
        exit 1
    fi
fi
echo $MODEL
