#!/bin/sh

CWD=$(dirname $0)

ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)
MODEL=$(/bin/sh $CWD/cbn_identify_model.sh)

case $MODEL in
    "CH6640")
        source $CWD/cbn_CH6640.lib
        login
        if [ "$login_resp" = "admin" ]; then
            return 0
        else
            return 1
        fi
        logout2;;
    "CH7466CE")
        source $CWD/cbn_CH7466CE.lib
        login
        if [ "$login_resp" = "false" ];then
            return 1
        else
            return 0
        fi
        logout2;;
    *)
        echo "Your used router model is not supported yet or you are still logged in your router interface. If so, please log out."
        exit 1;;
esac
