#!/bin/sh
CWD=$(dirname $0)
ROUTER_IP=$(/bin/sh $CWD/../general/get_router_ip.sh)
USERNAME=$1
source $CWD/../static.conf

curl_output=$(curl -s http://fritz.box/login_sid.lua)
CHALLENGE=$(echo $curl_output | \
    awk -F'<Challenge>' '{print $2}' | \
    awk -F'<' '{print $1}')
MD5=$(echo -n "${CHALLENGE}-${ROUTER_PASSWORD}" | \
    iconv -t utf-16le | md5sum | awk -F' ' '{print $1}')
URL="http://${ROUTER_IP}/login_sid.lua?username=${USERNAME}&response=${CHALLENGE}-${MD5}"
curl_output=$(curl -s $URL)
SID=$(echo $curl_output | \
    awk -F'<SID>' '{print $2}' | \
    awk -F'<' '{print $1}')
if [ "$SID" = "0000000000000000" ]; then
    return 1
else
    return 0
fi
