#!/bin/sh

CWD=$(dirname $0)
MAC=$(/bin/sh $CWD/get_router_mac.sh)
OUI=$(echo $MAC | awk -F':' '{print $1 ":" $2 ":" $3}')

case $OUI in
    # COMPAL
    "54:67:51" | \
        "90:5c:44" | \
        "38:43:7d" | \
        "34:2c:c4" | \
        "5c:35:3b" | \
        "ac:22:05" | \
        "dc:53:7c" ) 
        echo compal
        ;;
    # AVM
    "38:10:d5" | \
        "c8:0e:14" | \
        "7c:ff:4d" | \
        "98:9b:cb" | \
        "5c:49:79" | \
        "e8:df:70" | \
        "f0:b0:14" | \
        "44:4e:6d" | \
        "cc:ce:1e" | \
        "E0-28-6D") 
        echo avm;;
    "d8:58:d7")
        echo turris;;
    "24:df:6a" | \
        "d0:ff:98")
        echo speedport;;
esac
