#!/bin/sh 

echo "Mosquitto CID listener is starting!"

source ./static.conf
source ./dynamic.conf

mosquitto_sub -h "$SERVER" -t "$C_TOPIC" -p "8883" --capath /etc/ssl/certs -u "$C_USERNAME" -P "$C_PASSWORD" | while read RAW_DATA;
do	 
  case "$RAW_DATA" in
    *"ETUID"*) 
	UID="$(echo $RAW_DATA | cut -d':' -f2)"
	echo $UID
	echo $(date)' : Replace UID with new one'$UID >> /var/log/charlie.log;
	/bin/sed -i 's/^TOPIC.*/TOPIC="'$UID'\/'$CID'"/' /root/static.conf;
	/bin/sed -i 's/^USERNAME.*/USERNAME="'$UID'"/' /root/static.conf;
	/bin/sed -i 's/^UID_USER.*/UID_USER="'$UID'"/' /root/static.conf; 
	/bin/ash /root/upload_charlie.sh;
	/bin/ash /root/restart-mosquitto.sh;;
    *"ELETEUID"*)
	UID="$(echo $RAW_DATA | cut -d':' -f2)"
	echo $(date)' : Delete UID if UID = '$UID >> /var/log/charlie.log;
	/bin/sed -i 's/^TOPIC.*/TOPIC="-"/' /root/static.conf;
        /bin/sed -i 's/^USERNAME.*/USERNAME="-"/' /root/static.conf;
	/bin/sed -i 's/^UID_USER.*/UID_USER="-"/' /root/static.conf;
        /bin/ash /root/restart-mosquitto.sh;;
    *) echo $(date)' : CID Message received - but not valid' >> /var/log/charlie.log ;;
  esac
done
